Index: bridges/bridge_native_rtp.c
===================================================================
--- bridges/bridge_native_rtp.c	(revision 400862)
+++ bridges/bridge_native_rtp.c	(working copy)
@@ -272,6 +272,8 @@
 	RAII_VAR(struct ast_rtp_instance *, instance1, NULL, ao2_cleanup);
 	RAII_VAR(struct ast_rtp_instance *, vinstance0, NULL, ao2_cleanup);
 	RAII_VAR(struct ast_rtp_instance *, vinstance1, NULL, ao2_cleanup);
+	RAII_VAR(struct ast_rtp_instance *, tinstance0, NULL, ao2_cleanup);
+	RAII_VAR(struct ast_rtp_instance *, tinstance1, NULL, ao2_cleanup);
 
 	if (bridge->num_channels == 2) {
 		c0 = AST_LIST_FIRST(&bridge->channels);
@@ -284,6 +286,26 @@
 		 */
 		find_bridged_channels(bridge, leaving, &c0, &c1);
 	} else {
+		enum ast_rtp_glue_result audio_glue_res;
+		enum ast_rtp_glue_result video_glue_res;
+		enum ast_rtp_glue_result text_glue_res;
+
+		glue0 = ast_rtp_instance_get_glue(ast_channel_tech(leaving->chan)->type);
+		audio_glue_res = glue0->get_rtp_info(leaving->chan, &instance0);
+		video_glue_res = glue0->get_vrtp_info ? glue0->get_vrtp_info(leaving->chan, &vinstance0) : AST_RTP_GLUE_RESULT_FORBID;
+		text_glue_res = glue0->get_trtp_info ? glue0->get_trtp_info(leaving->chan, &tinstance0) : AST_RTP_GLUE_RESULT_FORBID;
+
+		/* Tear down P2P bridges */
+		ast_rtp_instance_set_bridged(instance0, NULL);
+		if (vinstance0) {
+			ast_rtp_instance_set_bridged(vinstance0, NULL);
+		}
+		if (tinstance0) {
+			ast_rtp_instance_set_bridged(tinstance0, NULL);
+		}
+
+		/* Direct RTP may have occurred, tear it down */
+		glue0->update_peer(leaving->chan, NULL, NULL, NULL, NULL, 0);
 		return;
 	}
 
